/**
 * @file TxtViewer.h
 * @brief eLXgr[A
 */
//---------------------------------------------------------------------------
#ifndef TxtViewerH
#define TxtViewerH

//---------------------------------------------------------------------------
#include "usr_mmfile.h"
#include "Global.h"

//---------------------------------------------------------------------------
/** N挟̐K\ */
#define LINK_MATCH_PTN	"(https?://[\\w/:%#$&?()~.=+-]+)|(file:///[^*?\"<>|)j]+\\.[a-zA-Z0-9]+)|(mailto:[a-zA-Z0-9]+[\\w.-]*@[\\w.-]+)"

/** P}b`pK\ */
#define WORD_MATCH_PTN	LINK_MATCH_PTN "|\\w+|[-]+|[-]+|[@-[]+|[-`-yO-X]+|[-]+|#[0-9a-fA-F]{3,6}"

#define MAX_BIN_HCH_X	67
#define MARK_WIDTH		8

#define MAX_EM_PTN		7	//!< \p^[

//---------------------------------------------------------------------------
/** @brief \se */
struct line_rec {
	int  LineNo;			//!< sԍ
	int  LineIdx;			//!< ssCfbNX
	bool hasCR;				//!< sɉsR[h
	WideChar topQch;
	int  RemPos0;			//!< RgJnʒu
	int  RemPos1;			//!< RgIʒu
	int  IndentN;			//!< CfgKCh
	int  StickyIdx;			//!< StickypCXg[(|1: ݒ)
};

//---------------------------------------------------------------------------
/**
 * @brief eLXgr[A
 */
class TTxtViewer
{
private:
	TPaintBox	*ViewBox;			//r[A`pPaintBox
	TCanvas		*ViewCanvas;
	TScrollBar	*ScrBar;
	UsrScrollPanel *ScrPanel;
	TPaintBox	*RulerBox;			//[
	TStatusBar	*SttHeader;			//Xe[^Xwb_
	TPaintBox	*MarginBox;			//E]

	bool isExtWnd;					//OEBhEŕ\

	UnicodeString EmPtn[MAX_EM_PTN];	//\p^[
	TColor EmFgC[MAX_EM_PTN];			//F
	TColor EmBgC[MAX_EM_PTN];			//wiF

	TPanel *ColorPanel;				//J[\ʒul̃J[\

	TPanel *StickyPanel;			//֐XeBbL[
	TPaintBox *StickyBox;
	UnicodeString StickyStr;		//XeBbL[\e
	int StickyLine;					//XeBbL[sԍ(1x[X)
	int LastTopPos;

	UnicodeString FuncPtn;			//֐}b`p^[
	UnicodeString FuncBrkPtn;		//֐u[Np^[
	UnicodeString FuncNamPtn;		//֐p^[

	Graphics::TBitmap *ImgBuff;

	TPoint LastPos;
	int	 LastTop;
	bool LastSel;
	bool SelSkip;
	bool inh_Repaint;

	TFont *UseFont;					//gptHg
	UnicodeString useFontName;		//gptHg
	int  useFontSize;				//gptHgTCY(Zbgl)

	int  FontHeight;				//tHg
	int  LineHeight;				//s
	int  HchWidth;					//p(px)
	int  TabWidth;					//^u(px)
	int  CurHchX;					//㉺ړXʒu(pP)
	int  MaxHchX;					//Xʒu̍ől(pP)
	int  LeftMargin;
	int  CurTop;					//\擪s(1x[X)
	int  CurBottom;					//\ŉs
	int  TopXpos;					//s̕\Jnʒu
	int  TopMargin;					//s̗]

	DynamicArray<int>  FixWdList;	//Œ蒷Xg
	DynamicArray<bool> IsNumList;	//ڂl

	TStringList *RemLnList;			//1sRgʕ
	TStringList *RemBgnList;		//ubNRgJn
	TStringList *RemEndList;		//ubNRgI

	UnicodeString QuotStr;			//̈p
	bool useEsc;					//ŃGXP[vV[PX

	UnicodeString ReservedPtn;		//\
	bool ReservedCase;				//\ő召

	UnicodeString SymbolChs;		//V{
	UnicodeString NumericPtn;		//l
	UnicodeString CharPtn;			//

	UnicodeString UsrKeyword;		//[U`L[[h
	bool   UsrKeywdCase;			//[U`L[[hő召
	TColor UsrKeywdCol;				//[U`L[[h̕F

	UnicodeString UsrKeyword2;		//[U`L[[h
	bool   UsrKeywdCase2;			//[U`L[[hő召
	TColor UsrKeywdCol2;			//[U`L[[h̕F

	TStringList *PairPtnList;		//SearchPair p̊Jn/Isp^[Xg

	TBytes FindByte0, FindByte1;	//oCi
	TBytes FindMask;				//oCip}XN

	bool alt_BackSlash;				//\  _(U+2216)ŕ\

	line_rec BinLineRec;
	line_rec* __fastcall AddDispLine(UnicodeString s, int lno, int lidx = 0);
	void __fastcall ClearDispLine();

	void __fastcall AlphaBlendCsvCol(TCanvas *cv, int max_x, int y, int h);
	void __fastcall onRulerPaint(TObject *Sender);
	void __fastcall onStickyPaint(TObject *Sender);
	void __fastcall onStickyClick(TObject *Sender);
	void __fastcall PaintText();
	bool __fastcall SetToggleSw(bool &sw, UnicodeString prm);

	void __fastcall SetScrBar();

	UnicodeString __fastcall ArrayToTsv(TStringDynArray lst);
	void __fastcall FormatFixed(TStringList *txt_lst);

	TPoint __fastcall nrm_Pos(TPoint p);
	bool __fastcall has_CR(UnicodeString s);
	int  __fastcall add_CharWidth(WideChar c, int w);
	int  __fastcall get_StrWidth(UnicodeString s);
	int  __fastcall get_CurEndPos();
	void __fastcall adjust_PosX();
	void __fastcall to_Lead_if_Trail(bool sel = false);
	void __fastcall set_SelEnd();
	void __fastcall set_CurCsvCol();

	WideChar __fastcall get_CurChar();
	int  __fastcall cv_PosX_to_HchX(int px);
	void __fastcall TabTextOut(UnicodeString s, TCanvas *cv, int &x, int max_x);
	void __fastcall IniSelected(bool sel = false);
	void __fastcall SetPosFromPt(int x, int y);
	bool __fastcall PtInSelected(int x, int y);
	void __fastcall UpdatePos(bool up_pos = false, bool force = false);
	void __fastcall UpdateSticky();
	void __fastcall UpdateVisible();
	int  __fastcall get_MovePrm(UnicodeString prm);
	int  __fastcall to_Bytes(UnicodeString s, bool &case_sw, int code_page = 932);

	int  __fastcall GetComCmdIndex(UnicodeString cmd);

public:
	TForm *OwnerForm;

	MemMapFile	 *MMF;				//!< }bvht@C

	TStringList  *TxtBufList;		//!< eXg
	TStringList  *TxtBufList2;		//!< HTMLTEXTϊ̓eXg/ `JSON
	TStringList  *DispLines;		//!< \sXg(eLXgp)

	UnicodeString FileName;			//!< t@C
	UnicodeString OrgName;			//!< ꎞ𓀂Ăꍇ̌t@C
	file_rec     *FileRec;
	bool 		  HasBOM;			//!< BOMt
	UnicodeString LineBreakStr;		//!< sR[h
	UnicodeString SttHdrInf;		//!< t@C
	UnicodeString MarkListStr;		//!< }[NXg

	bool isReady;
	bool isFitWin;					//!< ܂ԂEBhE
	bool isText;					//!< eLXg\
	bool isBinary;					//!< oCi\
	bool isXDoc2Txt;				//!< xdoc2txtgp
	bool isHtm2Txt;					//!< HTMLTEXTϊ[h
	bool isFixedLen;				//!< Œ蒷\[h
	bool isCSV;						//!< CSV(TSV܂)
	bool isTSV;
	bool isSelected;				//!< t@CI
	bool ShowRuby;					//!< r\
	bool isAozora;					//!< 󕶌Ɍ`
	bool isJsonFmt;					//!< `JSON
	bool isLog;						//!< ^XNO
	bool isClip;					//!< Nbv{[h
	bool isIniFmt;					//!< INIt@CȂ
	bool isAwstats;					//!< AwstatsO
	bool isNyanTxt;					//!< NyanFipeLXg
	bool isLimited;					//!< TCYL
	bool isContinue;				//!< Ōォ瑱
	bool isSelMode;					//!< I[h
	bool isBoxMode;					//!< `I[h
	bool ExtClicked;				//!< eLXgONbNꂽ
	bool Selecting;					//!< }EXőI
	bool PtInSelect;				//!< I͈͓NbN
	bool reqCurPos;					//!< ƂɃt@C[̃J[\ʒuݒ

	int  TabLength;					//!< ^u
	int  LineCount;					//!< 1y[W̍s(-1)
	int  MaxLine;					//!< ős
	int  MaxDispLine;				//!< ő\s

	bool isTail;					//!< \
	bool isReverse;					//!< t
	int  TailLine;					//!< s

	//TopIsHeader vpeB
	bool FTopIsHeader;
	void __fastcall SetTopIsHeader(bool Value);
	/** @brief 擪sCSVږ */
	__property bool TopIsHeader = {read = FTopIsHeader,  write = SetTopIsHeader};

	unsigned int BinarySize;		//!< oCiǍTCY
	unsigned __int64 BinFileSize;	//!< t@CTCY
	__int64 TopAddress;				//!< 擪AhX

	TPoint CurPos;					//!< J[\ʒu(P 0x[X)
	TPoint SelStart, SelEnd;		//!< ʏI͈(P)
	TPoint BoxStart, BoxEnd;		//!< `I͈(pP)

	TPoint PairPos1, PairPos2;		//!< Ή銇ʂ̈ʒu
	bool PairChanged;

	int  MaxFoldWd;					//!< ő܂Ԃ
	int  CsvCol;					//!< CSV(Œ蒷\[h)

	int  SortMode;					//!< \[g[h(0:Ȃ/ 1:/ -1:~)
	int  SortCol;					//!< \[g(Œ蒷\[h)

	UnicodeString JsonErrMsg;		//!< JSON̓G[

	UnicodeString FindWord;			//!< 
	UnicodeString RegExPtn;			//!< K\p^[
	UnicodeString LastSelWord;		//!< O FindSel`ŗp
	bool isCase;					//!< 召
	bool isRegEx;					//!< K\
	bool isWord;					//!< PPʂŌ
	bool isMigemo;					//!< Migemo[h
	bool isBytes;					//!< oCg񌟍
	int  BinCodePage;				//!< R[hy[W
	bool Highlight;					//!< }b`̋\
	bool LastFound;					//!< Ǒ
	TPoint FoundPos;				//!< Õqbgʒu

	UnicodeString IncSeaWord;		//!< CN^T[`͌
	bool isIncSea;					//!< CN^T[`
	bool isIncMigemo;				//!< Migemo[h

	UnicodeString HeadlinePtn;		//!< o̐K\
	UnicodeString RubyPtn;			//!< r̐K\

	TStringList *ColBufList;
	TColor color_Cursor;			//!< CJ[\̐F
	TColor color_selItem;			//!< Iڂ̔wiF
	TColor color_fgSelItem;			//!< Iڂ̕F
	TColor color_Folder;			//!< fBNg̕F
	TColor color_Error;				//!< G[̕F
	TColor color_bgView;			//!< eLXgr[A̔wiF
	TColor color_fgView;			//!< eLXgr[A̕F
	TColor color_Margin;			//!< eLXgr[A̗]
	TColor color_bgLineNo;			//!< eLXgr[A̍sԍwiF
	TColor color_LineNo;			//!< eLXgr[A̍sԍF
	TColor color_Mark;				//!< eLXgr[Ã}[N
	TColor color_bgRuler;			//!< [̔wiF
	TColor color_fgRuler;			//!< [̖ڐF
	TColor color_bdrLine;			//!< sԍ̋E
	TColor color_Indent;			//!< CfgKCh
	TColor color_Indent2;			//!< CfgKCh()
	TColor color_bdrFold;			//!< ܂ԂE
	TColor color_bdrFixed;			//!< Œ蒷\̏cr
	TColor color_Comment;			//!< Rg̕F
	TColor color_Strings;			//!< ̕F
	TColor color_Reserved;			//!< \̕F
	TColor color_Symbol;			//!< V{̕F
	TColor color_Numeric;			//!< l̕F
	TColor color_fgEmpBin1;			//!< oCiF1
	TColor color_fgEmpBin2;			//!< oCiF2
	TColor color_fgEmpBin3;			//!< oCiF3
	TColor color_Headline;			//!< o̕F
	TColor color_URL;				//!< URL̕F
	TColor color_LocalLink;			//!< [Jt@Cւ̃N
	TColor color_fgEmp;				//!< F
	TColor color_bgEmp;				//!< wiF
	TColor color_Ruby;				//!< r
	TColor color_TAB;				//!< ^u\F
	TColor color_CR;				//!< s\F
	TColor color_HR;				//!< r̐F
	TColor color_Ctrl;				//!< Rg[R[h
	TColor color_fgPair;			//!< Ή銇ʂ̕F

	/**
	 * @brief RXgN^
	 * @param frm tH[
	 * @param viewbox \̈
	 * @param scrbar XN[o[
	 * @param sp VvXN[o[
	 * @param stthdr wb_
	 * @param ruler [
	 * @param mgn_box E]pl
	 */
	TTxtViewer(TForm *frm, TPaintBox *viewbox, TScrollBar *scrbar, UsrScrollPanel *sp,
				TStatusBar *stthdr, TPaintBox *ruler, TPaintBox *mgn_box = NULL);
	~TTxtViewer();

	/** @brief ⏕ʂ */
	bool __fastcall CloseAuxForm();

	void __fastcall Clear();

	/** @brief zF̐ݒ */
	void __fastcall SetColor(TStringList *lst);
	void __fastcall SetColor(UnicodeString prm = EmptyStr);

	/** @brief IvVݒɔzF𔽉f */
	void __fastcall SetOptColor();

	/** @brief gbN̐ݒ */
	void __fastcall SetMetric(bool set_hi = false);

	/**
	 * @brief ֐̃}b`p^[擾
	 * @param[out] nam_ptn ֐̋p^[
	 * @param[out] cap_str ꗗpLvV
	 * @return UnicodeString 
	 */
	UnicodeString __fastcall GetFuncPtns(UnicodeString *nam_ptn = NULL, UnicodeString *cap_str = NULL);

	/**
	 * @brief ʂɍ킹čseݒ
	 * @param lno sԍ (0: ݍs)
	 */
	void __fastcall UpdateScr(int lno = 1);

	/**
	 * @brief eLXgeݒ
	 * @param[in] lst eLXge
	 * @param lno sԍ (0:Q)
	 * @param sort_mode \[g[h (0:/ 1:/ -1:~)
	 */
	void __fastcall AssignText(TStrings *lst = NULL, int lno = 1, int sort_mode = 0);

	/**
	 * @brief oCit@Cǂݍœeݒ
	 *
	 * @param top_adr 擪AhX
	 * @param reload ēǂݍ (false: }[N𕜌)
	 * @param adr ړAhX
	 * @return true
	 * @return false
	 */
	bool __fastcall AssignBin(__int64 top_adr = 0, bool reload = false, unsigned int adr = 0);

	/** @brief ĕ`v */
	void __fastcall Repaint(bool force = false);

	/** @brief wb_̃pl𒲐 */
	void __fastcall AdjustSttHdr();

	/**
	 * @brief ԕ\ݒ
	 * @param msg
	 */
	void __fastcall SetSttInf(UnicodeString msg = EmptyStr);

	/** @brief wb_̕` */
	void __fastcall SttHeaderDrawPanel(TStatusBar *StatusBar, TStatusPanel *Panel, TRect Rect);

	void __fastcall onMouseDown(int x, int y);
	void __fastcall onMouseMove(int x, int y);
	void __fastcall onMouseUp();
	void __fastcall onDblClick();
	void __fastcall onRulerDblClick(TObject *Sender);

	void __fastcall CursorLeft(bool sel = false);
	void __fastcall CursorRight(bool sel = false, bool skip_end = false);
	void __fastcall CursorUp(bool sel = false, UnicodeString prm = EmptyStr);
	void __fastcall CursorDown(bool sel = false, UnicodeString prm = EmptyStr);
	void __fastcall MovePage(bool is_down, bool sel = false);

	/** @brief XN[̕\ */
	void __fastcall ScrollAdjust();

	/**
	 * @brief XN[
	 * @param is_down 
	 * @param prm p[^
	 * @param move_csr J[\ړ
	 */
	void __fastcall MoveScroll(bool is_down, UnicodeString prm, bool move_csr = false);

	void __fastcall LineTop(bool sel = false);
	void __fastcall MoveLineTop(bool is_next, bool sel = false);
	void __fastcall LineEnd(bool sel = false);
	void __fastcall TextTop(bool sel = false);
	void __fastcall TextEnd(bool sel = false);

	/** @brief CSVʒu猅ݒ (R[h1sڂł̂ݗL) */
	bool __fastcall set_PosFromCol(int col);

	void __fastcall WordLeft(bool sel = false);
	void __fastcall WordRight(bool sel = false);

	/**
	 * @brief Nbv{[hɃRs[
	 * @param append ǉRs[
	 */
	void __fastcall ClipCopy(bool append = false);

	/** @brief ws̕\sR[h(line_rec)擾 */
	line_rec* __fastcall get_LineRec(int idx);
	UnicodeString __fastcall get_DispLine(int idx, int b0 = 0, int b1 = 15);

	/**
	 * @brief I𕶎擾
	 * @param clr_sel 擾AIԂNA
	 * @return UnicodeString 
	 */
	UnicodeString __fastcall get_SelText(bool clr_sel = false);

	/** @brief J[\ʒu/sURL擾 */
	UnicodeString __fastcall get_CurUrl();

	/**
	 * @brief J[\s̕擾
	 * @param to_cr s܂Ŏ擾
	 * @return UnicodeString 
	 */
	UnicodeString __fastcall get_CurLine(bool to_cr = false);

	/** @brief J[\s̍sԍ擾 */
	int __fastcall get_CurLineNo();

	/** @brief J[\ʒu̐΃AhX擾 (oCi) */
	__int64 __fastcall get_CurAddrA();

	/** @brief J[\ʒȗ΃AhX擾 (oCi) */
	unsigned int __fastcall get_CurAddrR();

	/** @brief s̃ItZbg擾 (oCi) */
	unsigned int __fastcall get_OfsR(int xp);

	/** @brief J[\ʒu̍s(y)E(x)擾 (eLXg) */
	TPoint __fastcall get_CurLinePos();

	/** @brief CSVoXg擾 */
	TStringDynArray __fastcall GetCsvHdrList();

	/** @brief SđI */
	void __fastcall SelectAll();

	/**
	 * @brief J[\ʒu̒P擾/I
	 * @param ptn }b`p^[
	 * @param[out] p_s Jnʒu
	 * @param[out] p_e Iʒu
	 * @return UnicodeString 
	 */
	UnicodeString __fastcall GetCurWord(UnicodeString ptn = EmptyStr, int *p_s = NULL, int *p_e = NULL);

	/**
	 * @brief J[\ʒu̒PI
	 * @param append ǉI
	 */
	void __fastcall SelCurWord(bool append = false);

	/** @brief sPʂōsŜI */
	void __fastcall SelLine(bool cr = false);

	void __fastcall saveDef_CodePage(int code_page);
	int  __fastcall change_CodePage(UnicodeString prm);

	/** @brief J[\ʒủ摜t@C擾 */
	UnicodeString __fastcall GetCurImgFile();

	/**
	 * @brief 񌟍
	 * @param is_down Ɍ
	 * @param kwd 
	 * @param opt IvV
	 * @return true 
	 * @return false 
	 */
	bool __fastcall SearchCore(bool is_down, UnicodeString kwd, SearchOption opt);

	bool __fastcall SearchDown(UnicodeString kwd, SearchOption opt);
	bool __fastcall SearchUp(UnicodeString kwd, SearchOption opt);

	/** @brief ɃoCg񌟍 */
	bool __fastcall SearchDownBytes(UnicodeString kwd, bool case_sw);
	/** @brief ɃoCg񌟍*/
	bool __fastcall SearchUpBytes(UnicodeString kwd, bool case_sw);

	/**
	 * @brief I𕶎
	 * @param up_sw Ɍ
	 * @param em_sw }b`\
	 * @return true 
	 * @return false 
	 */
	bool __fastcall SearchSel(bool up_sw, bool em_sw);

	/** @brief J[\ʒȗΉ銇ʂݒ */
	bool __fastcall UpdatePairPos();

	bool __fastcall SearchPairCore(UnicodeString bgn_ptn, UnicodeString end_ptn);

	/** @brief Ήsvf */
	bool __fastcall SearchPair(UnicodeString prm);

	/** @brief wsԍɈړ*/
	bool __fastcall ToLine(int lno, int col = -1);

	/** @brief TopAddress ̑΃AhXɈړ */
	bool __fastcall ToAddrR(unsigned int adr);

	/** @brief ΃AhXɈړ */
	bool __fastcall ToAddrA(__int64 adr);

	void __fastcall JumpLine(UnicodeString ln_str);

	void __fastcall MarkLine(int lno);
	bool __fastcall IsMarked(int lno = 0);

	/** @brief {ɒǉ */
	void __fastcall add_ViewHistory();

	/** @brief _vXg擾 */
	void __fastcall GetDumpList(TStringList *lst);

	/** @brief CN^T[` */
	void __fastcall IncSearch(UnicodeString keystr);

	/**
	 * @brief WL[ɑΉR}h擾
	 * @param keystr L[
	 * @return UnicodeString R}h
	 */
	UnicodeString __fastcall GetStdKeyCommand(UnicodeString keystr);

	/**
	 * @brief R}hs
	 * @param cmd R}h
	 * @param prm p[^
	 * @return true ꂽ
	 */
	bool __fastcall ExeCommand(const _TCHAR *cmd, UnicodeString prm = EmptyStr);

	/** @brief eLXgr[Aŗp\ȃR}hH */
	bool __fastcall IsCmdAvailable(UnicodeString cmd);

	/** @brief [hŗL̋֎~R}hH */
	bool __fastcall IsCmdInhibited(UnicodeString cmd);

	/** @brief HtmlToText ̃IvVݒ */
	void __fastcall SetHtmlToText(UnicodeString prm);
};
//---------------------------------------------------------------------------
extern TTxtViewer *TxtViewer;

//---------------------------------------------------------------------------
#endif
