/**
 * @file usr_scale.h
 * @brief XP[O
 */
//----------------------------------------------------------------------//
#ifndef UsrScaleH
#define UsrScaleH

//---------------------------------------------------------------------------
#include <Vcl.ComCtrls.hpp>
#include <Vcl.CheckLst.hpp>
#include <Vcl.Grids.hpp>

//---------------------------------------------------------------------------
#define DEFAULT_PPI	96	//!< ftHg(100\%)PPIl

/**
 * @brief ݂PPI擾
 * @param cp ΏۃRg[
 * @return int PPIl
 */
inline int GetCurPPI(TControl *cp = NULL)
{
	return (			cp? cp->CurrentPPI : 
		Screen->ActiveForm? Screen->ActiveForm->CurrentPPI
						  : Application->MainForm->CurrentPPI);
}

//----------------------------------------------------------------------
/** @brief g̃tH[ŃXP[Oꂽl擾 */
#define SCALED_THIS(n)		MulDiv(n, CurrentPPI, DEFAULT_PPI)

/** @brief g̃tH[ŃXP[OO(100\%)̐l擾 */
#define UNSCALED_THIS(n)	MulDiv(n, DEFAULT_PPI, CurrentPPI)

/** @brief CtH[ŃXP[Oꂽl擾 */
#define SCALED_MAIN(n)		MulDiv(n, Application->MainForm->CurrentPPI, DEFAULT_PPI)

//----------------------------------------------------------------------
/**
 * @brief XP[Oꂽl擾
 * @param n l
 * @param cp ΏۃRg[
 * @return int 
 */
inline int ScaledInt(int n, TControl *cp = NULL)
{
	return MulDiv(n, GetCurPPI(cp), DEFAULT_PPI);
}
//----------------------------------------------------------------------
/**
 * @brief XP[OO(100\%)̐l擾
 * @param n l
 * @param cp ΏۃRg[
 * @return int 
 */
inline int UnscaledInt(int n, TControl *cp = NULL)
{
	return MulDiv(n, DEFAULT_PPI, GetCurPPI(cp));
}

//----------------------------------------------------------------------
/**
 * @brief VXeEgbN̎擾
 * @param idx 
 * @param ppi 
 * @return int 
 */
inline int get_SysMetricsForPPI(int idx, int ppi)
{
	if (IsWindows10OrGreater())
		return GetSystemMetricsForDpi(idx, ppi);
	else
		return GetSystemMetrics(idx);
}

//---------------------------------------------------------------------------
/**
 * @brief wtHg̕`捂擾
 * @param font tHg
 * @param mgn }[W
 * @param min_mgn ŏ}[W
 * @return int `捂
 */
int get_FontHeightMgn(TFont *font, int mgn = 0, int min_mgn = 2);

/**
 * @brief wtHg̕`捂擾
 * @param font tHg
 * @param mgn }[W(100\%̒lAXP[OēKp)
 * @param min_mgn ŏ}[W(100\%̒lAXP[OēKp)
 * @return int `捂
 */
int get_FontHeightMgnS(TFont *font, int mgn = 0, int min_mgn = 2);

/**
 * @brief XP[OꂽtHg蓖Ă
 * @param s_font ̃tHg
 * @param font 蓖ĂtHg
 * @param cp PPI擾Rg[
 * @param size TCY
 * @param col F
 */
void AssignScaledFont(TFont *s_font, TFont *font, TControl *cp, int size = 0, TColor col = Graphics::clNone);

/**
 * @brief Rg[ɃXP[OꂽtHgݒ
 * @param cp ΏۃRg[
 * @param font tHg
 */
void AssignScaledFont(TWinControl *cp, TFont *font = NULL);

/**
 * @brief TLabel ɃXP[OꂽtHgݒ
 * @param lp Ώۃx
 * @param font tHg
 */
void AssignScaledFont(TLabel *lp, TFont *font = NULL);

/**
 * @brief TPaintBox ɃXP[OꂽtHgݒ
 * @param pp ΏۃyCg{bNX
 * @param font tHg
 */
void AssignScaledFont(TPaintBox *pp, TFont *font = NULL);

/**
 * @brief TCYXP[OꂽtHg擾
 * @param sz TCY
 * @param cp ΏۃRg[
 * @return int tHg
 */
int  ScaledFontHeight(int sz, TControl *cp);

//---------------------------------------------------------------------------
#endif

