/**
 * @file usr_shell.h
 * @brief VF֘Ȁ
 */
//---------------------------------------------------------------------------
#ifndef UserShellH
#define UserShellH

//---------------------------------------------------------------------------
#include <System.Math.hpp>

//---------------------------------------------------------------------------
#define WM_FORM_DROPPED  (WM_APP + 10)

//---------------------------------------------------------------------------
#define WICIMG_FRAME		0
#define WICIMG_PREVIEW		1
#define WICIMG_THUMBNAIL	2

//---------------------------------------------------------------------------
#define FPRP_NAM_WD		15				//!< ږ̍ő\(pP)

//񍀖ڂ̎ރtO
#define LBFLG_STD_FINF	0x00010000		//!< {t@C
#define LBFLG_PATH_FIF	0x00020000		//!< pX
#define LBFLG_FILE_FIF	0x00040000		//!< t@C
#define LBFLG_TIME_FIF	0x00080000		//!< ^CX^v
#define LBFLG_ATTR_FIF	0x00100000		//!< 
#define LBFLG_TAGS_FIF	0x00200000		//!< ^O
#define LBFLG_TYPE_FIF	0x00400000		//!< 

#define LBFLG_FEXT_FIF	0x01000000		//!< gqʃt@C
#define LBFLG_CRCD_FIF	0x02000000		//!< sR[h
#define LBFLG_ERR_FIF	0x04000000		//!< G[/x
#define LBFLG_DEBUG		0x08000000		//!< fobO
#define LBFLG_GIT_TAG	0x10000000		//!< Git^O
#define LBFLG_GIT_HASH	0x20000000		//!< GitnbV

//---------------------------------------------------------------------------
UnicodeString get_WndText(HWND hWnd);
UnicodeString get_WndClassName(HWND hWnd);

UnicodeString get_LocalFlderName(UnicodeString pnam);

UnicodeString get_PropTitle(UnicodeString s);
UnicodeString get_PropTitle(const _TCHAR *s);
UnicodeString make_PropLine(UnicodeString tit, UnicodeString str);
UnicodeString make_PropLine(const _TCHAR *tit, UnicodeString str);
UnicodeString make_PropLine(UnicodeString tit, int n);
UnicodeString make_PropLine(const _TCHAR *tit, int n);

void add_PropLine(UnicodeString tit, UnicodeString str, TStrings *lst, int flag = 0);
void add_PropLine(const _TCHAR *tit, UnicodeString str, TStrings *lst, int flag = 0);
void add_PropLine(UnicodeString tit, int n, TStrings *lst, int flag = 0);
void add_PropLine(const _TCHAR *tit, int n, TStrings *lst, int flag = 0);
void add_PropLine_if(const _TCHAR *tit, UnicodeString str, TStrings *lst, int flag = 0);

void add_WarnLine(UnicodeString str, TStrings *lst);

//---------------------------------------------------------------------------
extern HWND TargetHandle;
extern int  DragStartTag;
extern int  DroppedTag;
extern int  DroppedMode;
extern int  DefDropMode;
extern UnicodeString DragDrive;
extern bool DropRefused;

extern TStringList *DroppedList;
extern TListBox *L_FileListBox;
extern TListBox *R_FileListBox;

extern IContextMenu2 *ContextMenu2;
extern IContextMenu3 *ContextMenu3;

//---------------------------------------------------------------------------
struct drop_target_rec {
	TForm *TargetForm;
	TWinControl *TargetWinCtrl;
	HWND hTargetWnd;
};

//---------------------------------------------------------------------------
// TDropSource NX
//---------------------------------------------------------------------------
class TDropSource : public IDropSource
{
public:
	TDropSource() : FRefCount(0) { }
	HRESULT __stdcall QueryInterface(REFIID riid, void **ppv);
	ULONG   __stdcall AddRef();
	ULONG   __stdcall Release();
	HRESULT __stdcall QueryContinueDrag(BOOL fEsc, DWORD grfKeyState);
	HRESULT __stdcall GiveFeedback(DWORD dwEffect);

private:
	LONG FRefCount;
};

//---------------------------------------------------------------------------
// TDropTarget NX
//---------------------------------------------------------------------------
class TDropTargetBase : public IDropTarget
{
protected:
	unsigned int refCount;

	TDropTargetBase();
	virtual ~TDropTargetBase() { }

	virtual HRESULT __stdcall QueryInterface(const IID& iid, void **ppv);
	virtual ULONG __stdcall AddRef();
	virtual ULONG __stdcall Release();
};

//---------------------------------------------------------------------------
// TDropTarget NX
//---------------------------------------------------------------------------
class TDropTarget : public TDropTargetBase
{
public:
	static void CreateInstance(IDropTarget **pp);

private:
	virtual HRESULT __stdcall DragEnter(IDataObject *pDataObj, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);
	virtual HRESULT __stdcall DragOver(DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);
	virtual HRESULT __stdcall DragLeave();
	virtual HRESULT __stdcall Drop(IDataObject *pDataObj, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);
};

//---------------------------------------------------------------------------
/**
 * @brief hbv^[QbgEXg
 */
class TDropTargetList : public TList
{
private:
	drop_target_rec * __fastcall Get(int Index)
	{
		return (drop_target_rec*)(TList::Get(Index));
	}
	void __fastcall Put(int Index, drop_target_rec *Item)
	{
		TList::Put(Index, Item);
	}

	virtual void __fastcall Notify(void *Ptr, TListNotification Action);

public:
	__property drop_target_rec *Items[int Index] = {read=Get, write=Put};

	__fastcall TDropTargetList();
	void __fastcall AddNew(TForm *form, TWinControl *ctrl);
};

extern TDropTargetList *TargetList;
extern int TargetIndex;

//---------------------------------------------------------------------------
/**
 * @brief VF֘ȀNX
 */
class UserShell
{
private:
	TStringList *PropertyList;		//!< vpeB̍ڃXg (ږ=CfbNXNo.)

	TFPUExceptionMask FpuTmpMask;	//!< _O̗}~}XN
									//!<  .opus t@Cł̃G[΍

	IDataObject* GetFilePathDataObject(UnicodeString dnam, TStringList *flist);

	unsigned int   msRead_uint(TMemoryStream *ms, int ofs);
	unsigned short msRead_ushort(TMemoryStream *ms, int ofs);
	UnicodeString  msRead_strdat(TMemoryStream *ms, int &ptr, bool is_uc);

public:
	UserShell(HWND hWnd);
	~UserShell();

	int  PropNameWidth;		//!< vpeBږ̍ő\(pP)

	void AddTargetList(TForm *form, TWinControl *ctrl);
	void DelTargetItem(TForm *form);

	DWORD DoFilesDragDrop(UnicodeString dnam, TStringList *flist, int tag);
	DWORD DoClipDragDrop();

	/**
	 * @brief ReLXgj[\
	 * @param hWnd EBhEnh
	 * @param dnam fBNg
	 * @param flist ΏۃXg
	 * @param ex_item ǉj[ڃXg(LvV [TAB] R}h [TAB] ACR)
	 * @return UnicodeString s̏ꍇ "ERROR"AǉڂȂ炻̕AȊO EmptyStr
	 */
	UnicodeString ShowContextMenu(HWND hWnd, UnicodeString dnam, TStringList *flist, TStringList *ex_item);

	/**
	 * @brief //hCũReLXgj[\/wIDs
	 * @param EBhEnh
	 * @param drvnam hCu
	 * @param ex_item ǉj[ڃXg(LvV [TAB] R}hATuj[Ή)
	 * @param ex_ID R}hID(>0 ̏ꍇj[\IDs)
	 * @return UnicodeString s̏ꍇ "ERROR"AǉڂȂ炻̕AȊO EmptyStr
	 */
	UnicodeString DriveContextMenu(HWND hWnd, UnicodeString drvnam, TStringList *ex_item, int ex_ID = 0);

	/**
	 * @brief Copy/ Cut Ȃǂ̃R}hs
	 * @param hWnd EBhEnh
	 * @param dnam fBNg
	 * @param flist Ώۃt@CXg
	 * @param cmd R}h
	 * @return true
	 * @return false
	 */
	bool InvokeMenuCmd(HWND hWnd, UnicodeString dnam, TStringList *flist, LPCSTR cmd);

	/** @brief t@Cw肵Ďs */
	bool ShowFileRun();

	/**
	 * @brief V[gJbg̍쐬
	 * @param fnam t@C
	 * @param target
	 * @param cmdprm
	 * @param wdir
	 * @param desc
	 * @return true
	 * @return false
	 */
	bool CreateShortCut(UnicodeString fnam, UnicodeString target,
		UnicodeString cmdprm = EmptyStr, UnicodeString wdir = EmptyStr, UnicodeString desc = EmptyStr);

	UnicodeString get_PropInf(UnicodeString fnam, TStringList *lst = NULL, UnicodeString idx_str = EmptyStr, bool lst_sw = false);
	UnicodeString get_PropStr(UnicodeString fnam, UnicodeString prp_nam);
	UnicodeString get_VerStr(UnicodeString fnam);

	UnicodeString get_PropValue(TStringList *lst, UnicodeString name);
	int  get_Duration(UnicodeString fnam);

	/**
	 * @brief V[gJbg̎擾
	 * @param fnam t@C
	 * @param[out] lst 񃊃Xg
	 * @param[out] nam N
	 * @param[out] prm p[^
	 * @param[out] fld Əꏊ
	 * @param[out] shw s̑傫
	 * @param[out] rem Rg
	 * @param[out] is_ra Ǘ҂ƂĎs
	 * @return true
	 * @return false
	 */
	bool get_LnkInf(UnicodeString fnam, TStringList *lst, UnicodeString *nam = NULL,
		UnicodeString *prm = NULL, UnicodeString *fld = NULL, int *shw = NULL, UnicodeString *rem = NULL, bool *is_ra = NULL);

	/**
	 * @brief t@C̎ނ擾
	 * @param fnam t@C
	 * @return UnicodeString
	 */
	UnicodeString get_FileTypeStr(UnicodeString fnam);

	/**
	 * @brief V[gJbg̃N擾
	 * @param fnam t@C
	 * @return UnicodeString
	 */
	UnicodeString get_LnkName(UnicodeString fnam);

	HICON get_ico_f(UnicodeString fnam, int size, bool force = false);

	HICON get_Icon(UnicodeString fnam, int &size, bool chk_sz = true);

	/**
	 * @brief X[ACR擾
	 * @param fnam t@C
	 * @return HICON
	 */
	HICON get_SmallIcon(UnicodeString fnam);

	/**
	 * @brief X[ACR`
	 * @param fnam t@C
	 * @param cv LoX
	 * @param x Xʒu
	 * @param y Yʒu
	 * @param cp Rg[
	 * @return true
	 * @return false
	 */
	bool draw_SmallIcon(UnicodeString fnam, TCanvas *cv, int x, int y,TControl *cp = NULL);

	bool draw_SmallIcon(UnicodeString fnam, TImage *ip, TColor bg = clBtnFace, TControl *cp = NULL);

	/**
	 * @brief t@CTlC擾
	 * @param fnam t@C
	 * @param[out] o_bmp
	 * @param o_size
	 * @return true
	 * @return false
	 */
	bool  get_Thumbnail(UnicodeString fnam, Graphics::TBitmap *o_bmp, int o_size);

	/** @brief mpXGUIDpXɕϊ */
	UnicodeString KnownGuidStrToPath(UnicodeString s);

	/**@brief mpXIDpXɕϊ */
	UnicodeString KnownGuidToPath(REFKNOWNFOLDERID id);

	void AddKnownPath(REFKNOWNFOLDERID id, TStringList *lst, bool brk_sw = false);
	void AddEnvPath(UnicodeString enam, TStringList *lst, bool brk_sw = false);

	/**
	 * @brief tH_ꗗ擾([NXg`)
	 * @param[out] lst Xg 
	 */
	void get_SpecialFolderList(TStringList *lst);
};
//---------------------------------------------------------------------------
extern UserShell *usr_SH;
//---------------------------------------------------------------------------

#endif
